"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = styleable;

var _invariant = _interopRequireDefault(require("invariant"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _getDisplayName = _interopRequireDefault(require("./utils/get-display-name"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var isSpecialKey = function isSpecialKey(selector) {
  return selector === 'compose';
};

function getSelectorsInSetDifference() {
  var newCss = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var origCss = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var newSet = Object.keys(newCss);
  var origSet = Object.keys(origCss);
  return newSet.filter(function (selector) {
    return origSet.indexOf(selector) === -1;
  }).filter(function (selector) {
    return !isSpecialKey(selector);
  });
}

function areSelectorsMatchingSet(newCss, origCss) {
  return getSelectorsInSetDifference(newCss, origCss).length <= 0;
}

var rmSpecialCss = function rmSpecialCss(css) {
  var compose = css.compose,
      rest = _objectWithoutProperties(css, ["compose"]);

  return rest;
};

var compose = function compose() {
  var toCompose = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var css = arguments.length > 1 ? arguments[1] : undefined;
  return Object.keys(toCompose).reduce(function (acc, selector) {
    acc[selector] = css[selector] + ' ' + toCompose[selector];
    return acc;
  }, css);
};

var validate = function validate(origCss, newCss) {
  (0, _invariant["default"])(areSelectorsMatchingSet(newCss, origCss), 'Expected "this.props.css" to provide only selectors in the original stylesheet.  These selectors "%s" are not included in the stylesheet keys, "%s".', getSelectorsInSetDifference(newCss, origCss), Object.keys(origCss));
  (0, _invariant["default"])(areSelectorsMatchingSet(newCss.compose, origCss), 'Expected "this.props.css.compose" to provide only selectors in the original stylesheet.  These selectors "%s" are not included in the stylesheet keys, "%s".', getSelectorsInSetDifference(newCss.compose, origCss), Object.keys(origCss));
};

function styleable(origCss) {
  if (!origCss) origCss = {};
  if (_typeof(origCss) !== 'object' || Array.isArray(origCss)) throw new Error('stylesheet must be an object (ie, export object from a css module)');
  return function decorateSource(DecoratedComponent) {
    var Styleable = /*#__PURE__*/function (_React$Component) {
      _inherits(Styleable, _React$Component);

      var _super = _createSuper(Styleable);

      function Styleable() {
        _classCallCheck(this, Styleable);

        return _super.apply(this, arguments);
      }

      _createClass(Styleable, [{
        key: "getCss",
        value: function getCss() {
          var newCss = this.props.css || {};
          validate(origCss, newCss);

          var overridden = _objectSpread(_objectSpread({}, origCss), rmSpecialCss(newCss));

          var composed = compose(newCss.compose, overridden);
          return composed;
        }
      }, {
        key: "render",
        value: function render() {
          return /*#__PURE__*/_react["default"].createElement(DecoratedComponent, _extends({}, this.props, {
            css: this.getCss()
          }));
        }
      }]);

      return Styleable;
    }(_react["default"].Component);

    Styleable.displayName = "Styleable(".concat((0, _getDisplayName["default"])(DecoratedComponent), ")");
    Styleable.defaultProps = _objectSpread(_objectSpread({}, DecoratedComponent.defaultProps), {}, {
      css: {}
    });
    Styleable.propTypes = _objectSpread(_objectSpread({}, DecoratedComponent.propTypes), {}, {
      css: _propTypes["default"].object
    });
    return Styleable;
  };
}
//# sourceMappingURL=styleable.js.map